import org.nfunk.jep.*;
import org.nfunk.jep.function.*;
import java.util.*;
/**
 * Dcrivez votre classe Expression ici.
 * 
 * @author (votre nom) 
 * @version (un numro de version ou une date)
 */
public class Expression
{
    // variables d'instance - remplacez l'exemple qui suit par le vtre
    private String chaineOriginale="";
    private String chaineMinuscules;
    private JEP objetExpression;
    private boolean erreurParsing;
    private boolean erreurEval;
    private int posErreur=-1;


    /**
     * Constructeur d'objets de classe Expression
     */
    public Expression(String chaine)
    {
        chaineOriginale = chaine;
        chaineMinuscules = chaine.toLowerCase();
        objetExpression = new JEP();
        objetExpression.addStandardConstants();
        objetExpression.addStandardFunctions();
        objetExpression.setAllowUndeclared(true);
        objetExpression.setImplicitMul(true);
        
        objetExpression.addFunction("si",new If());
        objetExpression.addFunction("ent", new Floor());
        objetExpression.addFunction("arrondir", new Round());
        // ajouter les autres traductions ...
        
        
        objetExpression.parseExpression(chaineMinuscules);
    }
    
    public void valeur(String nom, double val)
    {
        objetExpression.setVarValue(nom,val);
        // Grer la possibilit que la variable n'existe pas ?
    }
    
    public double valeurVar(String nom)
    {
        return ((Double) objetExpression.getVarValue(nom)).doubleValue();
        // Grer la possibilit que la variable n'existe pas ?
    }
    
    public double eval()
    {
        return objetExpression.getValue();
        // Grer la possibilit d'erreurs d'valuation ?
    }
    
    public double eval(double x)
    {  
        objetExpression.setVarValue("x",x);
        return objetExpression.getValue();
        // Grer la possibilit d'erreurs d'valuation ?
    }
    
    public int posErreur()
    {
        String temp = objetExpression.getErrorInfo();
        if (temp == null) {return 0;}
        int debut = temp.indexOf("column ");
        int fin = temp.indexOf(".");
        return Integer.parseInt(temp.substring(debut+7,fin));
    }
    
    public String erreurParsing()
    {
        return objetExpression.getErrorInfo();
    }
    
    public boolean erreurEval()
    {
        return false;
    }
    
//***************** Ajouts 5 dcembre 2008 *********************
    public int nbDeVariables(){
        if (objetExpression.hasError()){return 0;};
        SymbolTable table = objetExpression.getSymbolTable();
        return table.size()-2;
    }
    
    public String[] nomsDesVariables(){
        
        if (objetExpression.hasError()){return null;}
        SymbolTable table = objetExpression.getSymbolTable();
        String[] nomsVar = new String[table.size()-2];
        int i = 0;
        for (Enumeration e = table.elements(); e.hasMoreElements();){
            Variable var = (Variable) e.nextElement();
            String leNom = (String) var.getName();
            if (!(leNom.equals("e")|| leNom.equals("pi"))){
                nomsVar[i] = leNom;
                i++;
            }
        }
        return nomsVar;
    }
    
    public String chaineOriginale(){
        return chaineOriginale;
    }
    
    public boolean isVar(String nom){
        SymbolTable table = objetExpression.getSymbolTable();
        return !(table.getVar(nom) == null);
    }
    
    public void addVar(String nom, double val){
        objetExpression.addVariable(nom, val);
    }
}
